function sharkIIvehicle::applyParts(%this, %veh, %part, %c, %vehname)
{
    //announce("applyParts " @ %this);
    if(!isObject(%veh)) return;

    if(%part $= "" || %part $= "all") %applyAll = true; else %applyAll = false;

    //announce("%applyAll is " @ %applyall);

    if(%applyAll || %part $= "headlight")
    {
        %veh.spawnbrick.visPart["headlight", %this.colorSchemeIdentifier] = %veh.visPart["headlight"];

        switch(%veh.visPart["headlight"])
        {
            case 0: //default
                if(%c > 0) %c.chatMessage(%vehname @ "\c8[\c20\c8 1] \c2Headlights\c6: Stock pop-up headlights. Headlights go up!");
                %veh.unhidenode(headlights); //stock wells
                %veh.unhidenode(headlightsR); //right side flip up
                %veh.unhidenode(headlightsL);
                %veh.hidenode(headlightsfixed);
            case 1:
                if(%c > 0) %c.chatMessage(%vehname @ "\c8[0 \c21\c8] \c2Headlights\c6: My Shark is best Shark because no pop-up headlights.");
                %veh.hidenode(headlights); //stock wells
                %veh.hidenode(headlightsR); //right side flip up
                %veh.hidenode(headlightsL);
                %veh.unhidenode(headlightsfixed);
        }
        
        %this.headlights(%veh, "restore");
    }


    if(%applyAll || %part $= "hood")
    {
        %veh.spawnbrick.visPart["hood", %this.colorSchemeIdentifier] = %veh.visPart["hood"];
        //announce("hood: " @ %veh.hood);
        switch(%veh.visPart["hood"])
        {
            case 0:
                if(%c > 0) %c.chatMessage(%vehname @ "\c8[\c10\c8 1 2 3] \c1Hood\c6: Blocky suggestive hood");
                %veh.partsBot.hidenode(h72);
                %veh.hidenode(h72str);
                %veh.hidenode(h72cs);
                %veh.partsBot.hidenode(h70);
                %veh.hidenode(h70str);
                %veh.hidenode(h70cs);
                %veh.partsBot.hidenode(h75);
                %veh.hidenode(h75str);
                %veh.hidenode(h75cs);
                %veh.partsBot.unhidenode(h69);
                %veh.unhidenode(h69str);
                %veh.unhidenode(h69cs);
            case 1:
                if(%c > 0) %c.chatMessage(%vehname @ "\c8[0 \c11\c8 2 3] \c1Hood\c6: Stock vented hood");
                %veh.partsBot.hidenode(h72);
                %veh.hidenode(h72str);
                %veh.hidenode(h72cs);
                %veh.partsBot.unhidenode(h70);
                %veh.unhidenode(h70str);
                %veh.unhidenode(h70cs);
                %veh.partsBot.hidenode(h75);
                %veh.hidenode(h75str);
                %veh.hidenode(h75cs);
                %veh.partsBot.hidenode(h69);
                %veh.hidenode(h69str);
                %veh.hidenode(h69cs);
            case 2:
                if(%c > 0) %c.chatMessage(%vehname @ "\c8[0 1 \c12\c8 3] \c1Hood\c6: Pointy understated hood");
                %veh.partsBot.unhidenode(h72);
                %veh.unhidenode(h72str);
                %veh.unhidenode(h72cs);
                %veh.partsBot.hidenode(h70);
                %veh.hidenode(h70str);
                %veh.hidenode(h70cs);
                %veh.partsBot.hidenode(h75);
                %veh.hidenode(h75str);
                %veh.hidenode(h75cs);
                %veh.partsBot.hidenode(h69);
                %veh.hidenode(h69str);
                %veh.hidenode(h69cs);
            case 3:
                if(%c > 0) %c.chatMessage(%vehname @ "\c8[0 1 2 \c13\c8] \c1Hood\c6: Smooth square hood");
                %veh.partsBot.hidenode(h72);
                %veh.hidenode(h72str);
                %veh.hidenode(h72cs);
                %veh.partsBot.hidenode(h70);
                %veh.hidenode(h70str);
                %veh.hidenode(h70cs);
                %veh.partsBot.unhidenode(h75);
                %veh.unhidenode(h75str);
                %veh.unhidenode(h75cs);
                %veh.partsBot.hidenode(h69);
                %veh.hidenode(h69str);
                %veh.hidenode(h69cs);
        }
    }

    if(%applyAll || %part $= "roof")
    {
        %veh.spawnbrick.visPart["roof", %this.colorSchemeIdentifier] = %veh.visPart["roof"];
        //announce("hood: " @ %veh.hood);
        switch(%veh.visPart["roof"])
        {
            case 0:
                if(%c > 0) %c.chatMessage(%vehname @ "\c8[\c20\c8 1 2] \c2Roof style\c6: Coupe with removable twin tops!");
                %veh.partsBot.hidenode(rconvert);
                %veh.hidenode(rconvertcs);
                %veh.partsBot.hidenode(rhtop);
                %veh.hidenode(rhtopcs);
                %veh.hidenode(rhtopint);

                %veh.partsBot.unhidenode(rcoupe);
                %veh.unhidenode(rcoupecs);
                %veh.unhidenode(rcoupeint);
                %veh.unhidenode(rcoupemet);

                %veh.partsBot.hidenode(rwagon);
                %veh.hidenode(rwagoncs);
                %veh.hidenode(rwagonint);

                if(!%veh.visPart["roofcover"])
                {
                    %veh.unhidenode(rttops);
                    %veh.unhidenode(rttopscs);
                    %veh.unhidenode(rttopsint);
                    %veh.hidenode(rack_lugband);
                    %veh.playThread(1, ttopup);
                }
                
                if(%veh.visPart["rack"] == 1)
                {
                    %veh.unhidenode(rack);
                    if(%veh.visPart["luggage"] == 1 && %veh.visPart["roofcover"])
                    {
                        %veh.unhidenode(rttops);
                        %veh.unhidenode(rttopscs);
                        %veh.unhidenode(rttopsint);
                        %veh.unhidenode(rack_lugband);
                        %veh.playThread(1, ttopdown);
                    }
                }

            case 1:
                if(%c > 0) %c.chatMessage(%vehname @ "\c8[0 \c21\c8 2] \c2Roof style\c6: Convertible!");
                %veh.partsBot.hidenode(rcoupe);
                %veh.hidenode(rcoupecs);
                %veh.hidenode(rcoupeint);
                %veh.hidenode(rcoupemet);

                %veh.hidenode(rttops);
                %veh.hidenode(rttopscs);
                %veh.hidenode(rttopsint);

                %veh.partsBot.hidenode(rwagon);
                %veh.hidenode(rwagoncs);
                %veh.hidenode(rwagonint);


                %veh.partsBot.unhidenode(rconvert);
                %veh.unhidenode(rconvertcs);

                if(!%veh.visPart["roofcover"])
                {
                    %veh.partsBot.unhidenode(rhtop);
                    %veh.unhidenode(rhtopcs);
                    %veh.unhidenode(rhtopint);
                }
                        
                if(%veh.visPart["rack"] == 1)
                    %veh.unhidenode(rack);

                %veh.hidenode(rack_lugband);
                    %veh.playThread(1, ttopup);

            case 2:
                if(%c > 0) %c.chatMessage(%vehname @ "\c8[0 1 \c22\c8] \c2Roof style\c6: Sportwagon, because the 1970s?");
                %veh.partsBot.hidenode(rconvert);
                %veh.hidenode(rconvertcs);
                %veh.partsBot.hidenode(rhtop);
                %veh.hidenode(rhtopcs);
                %veh.hidenode(rhtopint);

                %veh.partsBot.hidenode(rcoupe);
                %veh.hidenode(rcoupecs);
                %veh.hidenode(rcoupeint);
                %veh.unhidenode(rcoupemet);

                %veh.partsBot.unhidenode(rwagon);
                %veh.unhidenode(rwagoncs);
                %veh.unhidenode(rwagonint);

                if(!%veh.visPart["roofcover"])
                {
                    %veh.unhidenode(rttops);
                    %veh.unhidenode(rttopscs);
                    %veh.unhidenode(rttopsint);
                }
                else
                {
                    %veh.hidenode(rttops);
                    %veh.hidenode(rttopscs);
                    %veh.hidenode(rttopsint);
                }

                %veh.hidenode(rack);
                %veh.hidenode(rack_lugband);
                %veh.playThread(1, ttopup);
        }
    }

    if(%applyAll || %part $= "roofcover")
    {
        %veh.spawnbrick.visPart["roofcover", %this.colorSchemeIdentifier] = %veh.visPart["roofcover"];
        //announce("hood: " @ %veh.hood);
        switch(%veh.visPart["roofcover"])
        {
            case 0:
                if(%c > 0) %c.chatMessage(%vehname @ "\c8[\c30\c8 1] \c3Roof cover\c6: Yes.");
                switch(%veh.visPart["roof"])
                {
                    case 1: //Convertible
                        %veh.partsBot.unhidenode(rhtop);
                        %veh.unhidenode(rhtopcs);
                        %veh.unhidenode(rhtopint);
                    default: //All others use twin tops
                        %veh.unhidenode(rttops);
                        %veh.unhidenode(rttopscs);
                        %veh.unhidenode(rttopsint);
                        %veh.hidenode(rack_lugband);
                        %veh.playThread(1, ttopup);
                }
            case 1:
                if(%c > 0) %c.chatMessage(%vehname @ "\c8[0 \c31\c8] \c3Roof cover\c6: No.");
                switch(%veh.visPart["roof"])
                {
                    case 0:
                        if(%veh.visPart["rack"] == 1 && %veh.visPart["luggage"] == 1)
                        {
                            %veh.unhidenode(rttops);
                            %veh.unhidenode(rttopscs);
                            %veh.unhidenode(rttopsint);
                            %veh.playThread(1, ttopdown);
                            %veh.unhidenode(rack_lugband);
                        }
                        else
                        {
                            %veh.hidenode(rttops);
                            %veh.hidenode(rttopscs);
                            %veh.hidenode(rttopsint);
                        }
                    case 1: //Convertible
                        %veh.partsBot.hidenode(rhtop);
                        %veh.hidenode(rhtopcs);
                        %veh.hidenode(rhtopint);
                    case 2: //wagon
                        %veh.hidenode(rttops);
                        %veh.hidenode(rttopscs);
                        %veh.hidenode(rttopsint);
                }
        }
    }

    if(%applyAll || %part $= "exhaust")
    {
        %veh.spawnbrick.visPart["exhaust", %this.colorSchemeIdentifier] = %veh.visPart["exhaust"];
        //announce("hood: " @ %veh.hood);
        if(!%veh.visPart["exhaust"]) //apply rear exhaust
        {
            if(%c > 0) %c.chatMessage(%vehname @ "\c8[\c10\c8 1] \c1Exhaust\c6: Standard rear exhaust");
            %veh.hidenode(exside);
            %veh.hidenode(excovers);
            %veh.hidenode(excoversnp);

            if(%veh.visPart["bumper"] == 1) //rubber bumper needs different style of rear exhaust
            {
                %veh.hidenode(exrec);
                %veh.unhidenode(ex75);
            }
            else
            {
                %veh.unhidenode(exrec);
                %veh.hidenode(ex75);
            }
        }
        else //apply side exhaust
        {  
            if(%c > 0) %c.chatMessage(%vehname @ "\c8[0 \c11\c8] \c1Exhaust\c6: Side pipes, because you're worth it");
            %veh.unhidenode(exside);
            %veh.unhidenode(excovers);
            %veh.unhidenode(excoversnp);
            %veh.hidenode(exrec);
            %veh.hidenode(ex75);
        }
    }

    if(%applyAll || %part $= "vent")
    {
        %veh.spawnbrick.visPart["vent", %this.colorSchemeIdentifier] = %veh.visPart["vent"];
        //announce("hood: " @ %veh.hood);
        switch(%veh.visPart["vent"]) //vent decide
        {
            case 0: //'69
                if(%c > 0) %c.chatMessage(%vehname @ "\c8[\c30\c8 1 2] \c3Vent\c6: '60s-style side vent inspired by the gills of a shark");
                %veh.unhidenode(vent69);
                %veh.unhidenode(vent69met);

                %veh.hidenode(vent70);
                %veh.hidenode(vent70met);

                %veh.hidenode(vent75);

            case 1: //'70
                if(%c > 0) %c.chatMessage(%vehname @ "\c8[0 \c31\c8 2] \c3Vent\c6: \"Egg-crate\" side vent from the early '70s");
                %veh.hidenode(vent69);
                %veh.hidenode(vent69met);

                %veh.unhidenode(vent70);
                %veh.unhidenode(vent70met);

                %veh.hidenode(vent75);

            case 2: //'75
                if(%c > 0) %c.chatMessage(%vehname @ "\c8[0 1 \c32\c8] \c3Vent\c6: Simple side vent from the mid-'70s");
                %veh.hidenode(vent69);
                %veh.hidenode(vent69met);

                %veh.hidenode(vent70);
                %veh.hidenode(vent70met);

                %veh.unhidenode(vent75);
        }
    }

    if(%applyAll || %part $= "flare")
    {
        %veh.spawnbrick.visPart["flare", %this.colorSchemeIdentifier] = %veh.visPart["flare"];
        //announce("hood: " @ %veh.hood);
        switch(%veh.visPart["flare"])
        {
            case 0:
                if(%c > 0) %c.chatMessage(%vehname @ "\c8[\c40\c8 1 2] \c4Fender flares\c6: Paint-shielding flares for '70 and later");
                %veh.unhidenode(arches);
                %veh.unhidenode(arches70);
                %veh.hidenode(arches69);
                %veh.hidenode(archeswide);
            case 1:
                if(%c > 0) %c.chatMessage(%vehname @ "\c8[0 \c41\c8 2] \c4Fender flares\c6: Form-fitting flares from '68 and '69.");
                %veh.unhidenode(arches);
                %veh.hidenode(arches70);
                %veh.unhidenode(arches69);
                %veh.hidenode(archeswide);
            case 2:
                if(%c > 0) %c.chatMessage(%vehname @ "\c8[0 1 \c42\c8] \c4Fender flares\c6: Wide arches for wide tires. Type \c3/veh w 5\c6 to select wide custom wheels.");
                %veh.hidenode(arches);
                %veh.hidenode(arches70);
                %veh.hidenode(arches69);
                %veh.unhidenode(archeswide);
        }
    }

    if(%applyAll || %part $= "bumper")
    {
        %veh.spawnbrick.visPart["bumper", %this.colorSchemeIdentifier] = %veh.visPart["bumper"];
        //announce("hood: " @ %veh.hood);
        if(%veh.visPart["bumper"]) //it's 73 or higher
        {
            %veh.partsBot.hidenode(s70f); //hide the chrome bumper shape
            %veh.partsBot.hidenode(s70fstr);
            %veh.hidenode(s70fstripe);
            %veh.hidenode(s70flow);
            %veh.partsBot.hidenode(s70side);
            %veh.hidenode(s70met);

            if(%veh.visPart["bumper"] == 2) //73
            {
            if(%c > 0) %c.chatMessage(%vehname @ "\c8[0 1 \c02\c8] \c0Bumpers\c6: Rubber front bumper and chrome rear bumper, as seen in the 1973 Corvette.");
                %veh.unhidenode(s70r);
                %veh.unhidenode(s70rlow);
                %veh.unhidenode(s70rmet);

                %veh.hidenode(s75r);
                %veh.hidenode(s75rlow);
                %veh.hidenode(s75rnp);

                if(%veh.visPart["exhaust"] == 0)
                {
                    %veh.hidenode(ex75);
                    %veh.unhidenode(exrec);
                }
            }
            else
            {
            if(%c > 0) %c.chatMessage(%vehname @ "\c8[0 \c01\c8 2] \c0Bumpers\c6: Rubber bumpers from the mid-'70s, when power was reduced to save gas.");
                %veh.hidenode(s70r);
                %veh.hidenode(s70rlow);
                %veh.hidenode(s70rmet);

                %veh.unhidenode(s75r);
                %veh.unhidenode(s75rlow);
                %veh.unhidenode(s75rnp);

                if(%veh.visPart["exhaust"] == 0)
                {
                    %veh.unhidenode(ex75);
                    %veh.hidenode(exrec);
                }
            }

            if(%veh.visPart["stripe"] == 1) //bring out the rubber bumpers
            {
                %veh.partsBot.unhidenode(s75fstr);
                %veh.unhidenode(s75fstripe);
                %veh.partsBot.hidenode(s75f);
            }
            else
            {
                %veh.partsBot.hidenode(s75fstr);
                %veh.hidenode(s75fstripe);
                %veh.partsBot.unhidenode(s75f);
            }

            %veh.unhidenode(s75flow);
            %veh.partsBot.unhidenode(s75side);
            %veh.unhidenode(s75np);
        }
        else //it's 69 or 70
        {
            if(%c > 0) %c.chatMessage(%vehname @ "\c8[\c00\c8 1 2] \c0Bumpers\c6: Classic chrome bumpers (sadly just light gray, because Blockland) for '68 to '72.");
            if(%veh.visPart["stripe"] == 1) //doesn't actually look like chrome but cool nonetheless
            {
                %veh.partsBot.unhidenode(s70fstr);
                %veh.unhidenode(s70fstripe);
                %veh.partsBot.hidenode(s70f);
            }
            else
            {
                %veh.partsBot.hidenode(s70fstr);
                %veh.hidenode(s70fstripe);
                %veh.partsBot.unhidenode(s70f);
            }
            %veh.unhidenode(s70flow);
            %veh.unhidenode(s70r);
            %veh.unhidenode(s70rlow);
            %veh.partsBot.unhidenode(s70side);
            %veh.unhidenode(s70met);
            %veh.unhidenode(s70rmet);


            %veh.partsBot.hidenode(s75f); //no
            %veh.partsBot.hidenode(s75fstr);
            %veh.hidenode(s75fstripe);

            %veh.hidenode(s75flow);
            %veh.hidenode(s75r);
            %veh.hidenode(s75rlow);
            %veh.partsBot.hidenode(s75side);
            %veh.hidenode(s75np);
            %veh.hidenode(s75rnp);

            if(%veh.visPart["exhaust"] == 0)
            {
                %veh.hidenode(ex75);
                %veh.unhidenode(exrec);
            }
        }
        
        %this.headlights(%veh, "restore");  //apply lights in case turn signal location changed
    }

    if(%applyAll || %part $= "stripe")
    {
        %veh.spawnbrick.visPart["stripe", %this.colorSchemeIdentifier] = %veh.visPart["stripe"];

        if(%veh.visPart["bumper"])
            %year = 75;
        else
            %year = 70;

        switch(%veh.visPart["stripe"])
        {
            case 0:
            if(%c > 0) %c.chatMessage(%vehname @ "\c8[\c00\c8 1 2] \c0Stripe\c6: Standard hood stripe, which changes with the hood type. Type \c3/veh t 1\c6 to select it for painting.");
                %veh.partsBot.hidenode(s@%year@fstr);
                %veh.hidenode(s@%year@fstripe);
                %veh.partsBot.unhidenode(s@%year@f);
                %veh.spawnbrick.colorSchemeNodes[%this.colorSchemeIdentifier, 1] = "h69str h70str h72str h75str";
                %veh.colorSchemeNodes[1] = "h69str h70str h72str h75str";

            case 1:
            if(%c > 0) %c.chatMessage(%vehname @ "\c8[0 \c01\c8 2] \c0Stripe\c6: Square front stripe covering the headlights. Type \c3/veh t 1\c6 to select it for painting.");
                %veh.partsBot.unhidenode(s@%year@fstr);
                %veh.unhidenode(s@%year@fstripe);
                %veh.partsBot.hidenode(s@%year@f);
                %veh.spawnbrick.colorSchemeNodes[%this.colorSchemeIdentifier, 1] = "s70fstripe s75fstripe headlights headlightsL headlightsR headlightsfixed";
                %veh.colorSchemeNodes[1] = "s70fstripe s75fstripe headlights headlightsL headlightsR headlightsfixed";

            case 2:
            if(%c > 0) %c.chatMessage(%vehname @ "\c8[0 1 \c02\c8] \c0Stripe\c6: Wide stripe starting on the hood and covering the rear. Type \c3/veh t 1\c6 to select it for painting.");
                %veh.partsBot.hidenode(s@%year@fstr);
                %veh.hidenode(s@%year@fstripe);
                %veh.partsBot.unhidenode(s@%year@f);
                %veh.spawnbrick.colorSchemeNodes[%this.colorSchemeIdentifier, 1] = "h69str h69cs h70str h70cs h72str h72cs h75str h75cs rttopscs rhtopcs rcoupecs rconvertcs rwagoncs s75r s75rlow s70r s70rlow excovers";
                %veh.colorSchemeNodes[1] = "h69str h69cs h70str h70cs h72str h72cs h75str h75cs rttopscs rhtopcs rcoupecs rconvertcs rwagoncs s75r s75rlow s70r s70rlow excovers";
        }
        
        %colorSchemeTargetRestore = %veh.colorSchemeTarget;
        %veh.colorSchemeTarget = 0;
        if(%brick.reColorVehicle)
            %brick.colorVehicle();
        else
            %veh.setNodeColor("ALL", %veh.colorSchemeColor[0]); //Reapply current color to cause changes
        %veh.colorSchemeTarget = %colorSchemeTargetRestore;
    }

    if(%applyAll || %part $= "rack")
    {
        %veh.spawnbrick.visPart["rack", %this.colorSchemeIdentifier] = %veh.visPart["rack"];
        //announce("hood: " @ %veh.hood);
        if(!%veh.visPart["rack"])
        {
            if(%c > 0) %c.chatMessage(%vehname @ "\c8[\c40\c8 1] \c4Luggage rack\c6: No");
            %veh.hidenode(rack);
            %veh.hidenode(rack_lugband);
            if(%veh.visPart["roofcover"] == 1)
            {
                %veh.hidenode(rttops);
                %veh.hidenode(rttopscs);
                %veh.hidenode(rttopsint);
            }
            // %veh.hidenode(luggage);
        }
        else
        {
            if(%veh.visPart["roof"] != 2) //sport wagon
                %veh.unhidenode(rack);
            
            if(%c > 0) %c.chatMessage(%vehname @ "\c8[0 \c41\c8] \c4Luggage rack\c6: Yes! Hidden when combined with the sportwagon roof.");
        }
        %this.applyParts(%veh, "luggage");
    }

    if(%applyAll || %part $= "luggage")
    {
        %veh.spawnbrick.visPart["luggage", %this.colorSchemeIdentifier] = %veh.visPart["luggage"];
        //announce("hood: " @ %veh.hood);
        switch(%veh.visPart["luggage"]) //
        {
            case 0:
                if(%veh.visPart["roofcover"] == 1) //If roof is uncovered
                {
                    %veh.hidenode(rttops); //Don't show these anywhere
                    %veh.hidenode(rttopscs);
                    %veh.hidenode(rttopsint);
                }
                %veh.hidenode(rack_lugband);
                %veh.playThread(1, ttopup);
                // %veh.hidenode(luggage);
                if(%c > 0) %c.chatMessage(%vehname @ "\c8[\c50\c8 1] \c5Luggage\c6: No luggage, just rack.");
            case 1:
                if(%veh.visPart["roof"] != 2 && %veh.visPart["rack"] == 1)
                {
                    %veh.unhidenode(rack);
                    %veh.hidenode(luggage);
                    if(%veh.visPart["roof"] != 1 && %veh.visPart["roofcover"] == 1) //Twin tops are used and twin tops are not in use
                    {
                        %veh.unhidenode(rttops);
                        %veh.unhidenode(rttopscs);
                        %veh.unhidenode(rttopsint);
                        %veh.unhidenode(rack_lugband);
                        %veh.playThread(1, ttopdown);
                    }
                }
                if(%c > 0) %c.chatMessage(%vehname @ "\c8[0 \c51\c8] \c5Luggage\c6: Twin tops (coupe roof style only) will be stored on the luggage rack when not in use.");
            case 2: //CURRENTLY INACCESSIBLE
                if(%veh.visPart["roof"] == 2)
                {
                    if(%c > 0) %c.chatMessage(%vehname @ "BAGS FOR THE BAG THRONE I mean sportwagon oh wait NOTHING IS HERE YET SORRY");
                }
                else
                {
                    if(%c > 0) %c.chatMessage(%vehname @ "LUGGAGE FOR THE LUGGAGE GOD I mean rack");
                    %veh.unhidenode(rack);
                    %veh.unhidenode(luggage);
                    %veh.hidenode(rttops_lug);
                    %veh.hidenode(rttopscs_lug);
                    %veh.hidenode(rttopsint_lug);
                    %veh.hidenode(rttops_lugband);
                }
        }
    }
}