function sharkIIblockoVehicle::applyParts(%this, %veh, %part, %c, %vehname)
{
    return sharkIIvehicle::applyParts(%this, %veh, %part, %c, %vehname);
}

function sharkIIblockoVehicle::onTrigger(%this, %veh, %slot, %val)
{
    return sharkIIvehicle::onTrigger(%this, %veh, %slot, %val);
}

function sharkIIblockoVehicle::headlights(%this, %veh, %directive, %selection)
{
    return sharkIIvehicle::headlights(%this, %veh, %directive, %selection);
}

function sharkIIblockoVehicle::turnSignal(%this, %veh, %direction)
{
   return sharkIIvehicle::turnSignal(%this, %veh, %direction);
}

//PACKAGED FUNCTIONS ARE PART OF BASE_SCRIPT_ONADD

function sharkIIblockoVehicle::onDriverEnter(%this, %veh)
{
    return sharkIIVehicle::onDriverEnter(%this, %veh);
}

function sharkIIblockoVehicle::onDriverLeave(%this, %veh)
{
    return sharkIIVehicle::onDriverLeave(%this, %veh);
}

function sharkIIblockoVehicle::onRemove(%this, %veh)
{
    %veh.removeMountedLightBot(2);
}

function sharkIIblockoVehicle::SpeedCheck(%this, %veh)
{
    if(isEventPending(%veh.SpeedCheckSchedule)) return;
    if(!isObject(%veh)) return;
    
    %veh.speed = vectorDot(%veh.getVelocity(), %veh.getForwardVector());
    
    if(!%veh.reversing && %veh.speed <= -3)
    {
        %veh.partsBot.hidenode(lights_reverse0);
        %veh.partsBot.unhidenode(lights_reverse1);
        %veh.reversing = 1;
    }
    else if(%veh.reversing && %veh.speed > -0.1)
    {
        %veh.partsBot.unhidenode(lights_reverse0);
        %veh.partsBot.hidenode(lights_reverse1);
        %veh.reversing = 0;
    }
    
    %veh.SpeedCheckSchedule = %this.schedule(250, "SpeedCheck", %veh);
}

function sharkIIblockoVehicle::VehicleEditHelper(%this, %veh, %c, %arg1, %arg2, %arg3)
{
    return sharkIIvehicle::VehicleEditHelper(%this, %veh, %c, %arg1, %arg2, %arg3);
}

function sharkIIblockoVehicle::shiftBrickCarControls(%this, %veh, %client, %node, %input, %super)
{
    return sharkIIvehicle::shiftBrickCarControls(%this, %veh, %client, %node, %input, %super);
}