datablock WheeledVehicleData(sharkIIblockoVehicle : sharkIIvehicle)
{
	uiName = "Shark II Blocko handling";

	defaultTire = sharkIIblockotire;
	defaultSpring = sharkIIblockospring;

	engineTorque = 6000;
	engineBrake = 1500;
	brakeTorque = 6000;
	maxWheelSpeed = 50;

	massCenter = "0 0 0.1";

	tireemitter = vehicletireemitter;

	visPartDefault["hood"] = 3;
	visPartDefault["exhaust"] = 0;
	visPartDefault["flare"] = 0;
	visPartDefault["vent"] = 2;
	visPartDefault["bumper"] = 2;

};

datablock WheeledVehicleTire(sharkIIblockotire)
{
	shapeFile = "./shapes/wheelblocko.dts";
	
	mass = 10;
	radius = 1;
	staticFriction = 5;
	kineticFriction = 5;
	restitution = 0.5;	

	lateralForce = 20000;
	lateralDamping = 1000;
	lateralRelaxation = 1;

	longitudinalForce = 10000;
	longitudinalDamping = 1000;
	logitudinalRelaxation = 0.5;
};


datablock WheeledVehicleSpring(sharkIIblockospring)
{
	length = 0.35;
	force = 4000;
	damping = 1000;
	antiSwayForce = 0;
};